Rem small prime number sieve.
DefLng A-Z
Rem $Dynamic
Declare Function FormatString$ (s)
On Error GoTo ErrorRoutine
Color 15
Print "Prime sieve calcuator."
_Title "Prime sieve calculator"
_ScreenMove _Middle
StartLoop:
Color 14
Do
   Print "Enter sieve array size(10-32767)";
   Input m: m = CInt(m)
   If m >= 10 And m <= 32767 Then
      Exit Do
   End If
Loop
d = m ^ 2
ReDim p(d) As Long
ReDim q(m) As Long
On Timer(1) GoSub StatusLine
Timer On
Print "Sieve array size "; FormatString$(d * 4)
Print "Prime array size "; FormatString$(m * 4)
Print "Calculating sieve.."
T1! = Timer
For x = 2 To m
   For l = x + x To d Step x
      If l <= d Then
         p(l) = -1
      End If
   Next
Next
Print "Storing sieve.."
z = 0
For l = 2 To d
   If p(l) = 0 Then
      z = z + 1
      If z <= m Then
         q(z) = l
      Else
         Exit For
      End If
   End If
Next
Timer Off
GoSub ClearStatusLine
Color 15
E! = Timer - T1!
If E! < 0! Then E! = E! + 86400!
Select Case E!
   Case 0!
      Print "Time elapsed is zero seconds."
   Case Is < 1!
      If E! >= .5 Then
         E$ = LTrim$(Str$(E!))
         If InStr(E$, ".") Then E$ = Left$(E$, InStr(E$, ".") + 2)
         Print "Time elapsed: "; E$; " seconds."
      Else
         Print "Time elapsed is less than one second."
      End If
   Case Is >= 1!
      E$ = LTrim$(Str$(E!))
      If InStr(E$, ".") Then E$ = Left$(E$, InStr(E$, ".") + 2)
      Print "Time elapsed: "; E$; " seconds."
End Select
Print "Display primes(y/n)?";
Do
   x$ = InKey$
   If Len(x$) Then
      If LCase$(x$) = "n" Then z = z - 1: Print: GoTo EndProgram
      If LCase$(x$) = "y" Then Print: Exit Do
   End If
Loop
Print "Displaying primes.."
c = 0
b = 0
n = 1
z = 0
For l = 1 To m
   If q(l) Then
      z = z + 1
      p = q(l)
      p1$ = LTrim$(Str$(p))
      If Len(p1$) <= 6 Then
         p1$ = Left$(p1$, 6)
         p1$ = p1$ + Space$(6 - Len(p1$))
         Color 15
         Print p1$; " ";
      Else
         p1$ = Left$(p1$, 7)
         p1$ = p1$ + Space$(7 - Len(p1$))
         Color 15
         Print p1$;
      End If
      c = c + 1
      If c = 11 Then
         c = 0
         Print
         n = n + 1
         If n = 23 Then
            n = 0
            If b = 0 Then
               Color 14
               Print "-more(y/n/c)-";
               Do
                  x$ = InKey$
                  If Len(x$) Then
                     x$ = LCase$(x$)
                     If x$ = "?" Then
                        Color 15
                        Print
                        Print " <space>, <enter>, 'y' to continue."
                        Print " 'n', 'q' exit display."
                        Print " 'c' continuous display."
                        Color 14
                        Print "-more(y/n/c/q)-";
                     End If
                     If x$ = " " Or x$ = "y" Or x$ = Chr$(13) Then Print: Exit Do
                     If x$ = "n" Or x$ = "q" Then Exit For
                     If x$ = "c" Then b = -1: Print: Exit Do
                  End If
               Loop
            End If
         End If
      End If
   End If
Next
Print
EndProgram:
Print "Primes: "; FormatString$(z)
Print "Run again(y/n)?";
Do
   x$ = InKey$
   If Len(x$) Then
      x$ = LCase$(x$)
      If x$ = "n" Then Print: Exit Do
      If x$ = "y" Then Print: GoTo StartLoop
   End If
Loop
Color 7
End

ErrorRoutine:
Color 12
If Err = 6 Then
   Print "Overflow. Reduce array size."
   Resume StartLoop
End If
Print "Critical error"; Err
Color 7
End

StatusLine:
Color 15
X1 = CsrLin
Y1 = Pos(0)
Locate 25, 1, 1
Print "Sieve Calculate"; x; "of"; m;
Locate X1, Y1, 1
Color 14
Return

ClearStatusLine:
X1 = CsrLin
Y1 = Pos(0)
Locate 25, 1, 1
Print Space$(79);
Locate X1, Y1, 1
Return

' formats a numeric string.
Function FormatString$ (s)
   x$ = ""
   s$ = Str$(s)
   s$ = LTrim$(s$)
   If InStr(s$, ".") Then s$ = Left$(s$, InStr(s$, ".") - 1)
   For l = Len(s$) To 3 Step -3
      x$ = Mid$(s$, l - 2, 3) + "," + x$
   Next
   If l > 0 Then
      x$ = Mid$(s$, 1, l) + "," + x$
   End If
   If Len(s$) < 3 Then
      x$ = s$
   End If
   If Right$(x$, 1) = "," Then
      x$ = Left$(x$, Len(x$) - 1)
   End If
   FormatString$ = x$
End Function

